import { PitayaView } from "./view";

/**
 * @class
 * Should be used as super class for components
 */
export abstract class PitayaComponent
{
	public identifier: number | string;

	protected _rootElement: HTMLElement;

	get rootElement(): HTMLElement
	{
		return this._rootElement;
	}

	/**
	 * Returns the identifier of this component. Creates one if necessary.
	 */
	protected _generateOwnId(): number | string
	{
		if( this.identifier === undefined || this.identifier === "" )
		{
			this.identifier = PitayaView.instance.getNewId();
		}

		return this.identifier;
	}
}